package com.vctgo.system.mapper;

import com.baomidou.mybatisplus.annotation.InterceptorIgnore;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.vctgo.common.mybatisplus.mapper.BaseMapperX;
import com.vctgo.system.domain.SysPlatformPost;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 岗位信息 数据层
 *
 * @author vctgo
 */
@Repository
 public interface SysPlatformPostMapper extends BaseMapperX<SysPlatformPost>
{
    /**
     * 查询岗位数据集合-分页
     *
     * @param post 岗位信息
     * @return 岗位数据集合
     */
    IPage<SysPlatformPost> selectPostList(Page page,@Param("query") SysPlatformPost post);
    /**
     * 查询岗位数据集合
     *
     * @param post 岗位信息
     * @return 岗位数据集合
     */
     List<SysPlatformPost> selectPostList(@Param("query") SysPlatformPost post);

    /**
     * 查询所有岗位
     *
     * @return 岗位列表
     */
     List<SysPlatformPost> selectPostAll();

    /**
     * 通过岗位ID查询岗位信息
     *
     * @param postId 岗位ID
     * @return 角色对象信息
     */
    SysPlatformPost selectPostById(Long postId);

    /**
     * 根据用户ID获取岗位选择框列表
     *
     * @param userId 用户ID
     * @return 选中岗位ID列表
     */
     List<Long> selectPostListByUserId(Long userId);

    /**
     * 查询用户所属岗位组
     *
     * @param userName 用户名
     * @return 结果
     */
     List<SysPlatformPost> selectPostsByUserName(String userName);

    /**
     * 删除岗位信息
     *
     * @param postId 岗位ID
     * @return 结果
     */
     int deletePostById(Long postId);

    /**
     * 批量删除岗位信息
     *
     * @param postIds 需要删除的岗位ID
     * @return 结果
     */
     int deletePostByIds(Long[] postIds);

    /**
     * 修改岗位信息
     *
     * @param post 岗位信息
     * @return 结果
     */
     int updatePost(SysPlatformPost post);

    /**
     * 新增岗位信息
     *
     * @param post 岗位信息
     * @return 结果
     */
     int insertPost(SysPlatformPost post);

    /**
     * 校验岗位名称
     *
     * @param postName 岗位名称
     * @return 结果
     */
    SysPlatformPost checkPostNameUnique(String postName);

    /**
     * 校验岗位编码
     *
     * @param postCode 岗位编码
     * @return 结果
     */
    SysPlatformPost checkPostCodeUnique(String postCode);


    /**
     * 批量删除岗位信息-根据租户
     *
     * @param ids 需要删除的岗位租户id
     * @return 结果
     */
    @InterceptorIgnore(tenantLine = "1")
    int deletePostByTenantId(Long[] ids);
}
